include:
  - "https://gitlab.com/vibhav.bobde/ci-test/raw/test/cluster.gitlab-ci.yml"
    
variables:
  REGISTRY: registry.uffizzi.com/$CI_PIPELINE_ID
  TAG: latest
  VOTE_IMAGE: $REGISTRY/vote:$TAG
  WORKER_IMAGE: $REGISTRY/worker:$TAG
  RESULT_IMAGE: $REGISTRY/result:$TAG
  UFFIZZI_COMPOSE_FILE: docker-compose.rendered.yml
    
.build_image: &build_image
  stage: build
  image: docker:latest
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
  script:
    - docker build -t $IMAGE $DOCKERFILE_PATH
    - docker push $IMAGE

services:
  - docker:dind

stages:
  - build
  - uffizzi_cluster_deploy
  - kustomize_apply
  - uffizzi_cluster_delete

build_vote:
 <<: *build_image
 variables:
   DOCKERFILE_PATH: ./vote
   IMAGE: $VOTE_IMAGE

build_worker:
 <<: *build_image
 variables:
   DOCKERFILE_PATH: ./worker
   IMAGE: $WORKER_IMAGE

build_result:
 <<: *build_image
 variables:
   DOCKERFILE_PATH: ./result
   IMAGE: $RESULT_IMAGE

kustomize:
  extends: .kustomize_template
  script:
    - |
      cat kustomization.yaml
      echo "`pwd`"
      echo "`ls`"
      export CLUSTER_NAME=mr-$CI_MERGE_REQUEST_ID

      # Change the image name to those just built and pushed.
      ./kustomize edit set image dockersamples/examplevotingapp_vote=$VOTE_IMAGE
      ./kustomize edit set image dockersamples/examplevotingapp_result=$RESULT_IMAGE
      ./kustomize edit set image dockersamples/examplevotingapp_worker=$WORKER_IMAGE

      # Apply kustomized manifests to virtual cluster.
      ./kubectl apply --kustomize . --kubeconfig ./kubeconfig

      # Imperatively create Ingress resources for the two HTTP endpoints.
      export VOTE_HOST="$CLUSTER_NAME-$CI_PROJECT_ID-vote.uclusters.app.uffizzi.com"
      export RESULT_HOST="$CLUSTER_NAME-$CI_PROJECT_ID-result.uclusters.app.uffizzi.com"

      if ./kubectl get ingress vote-$CI_MERGE_REQUEST_ID --kubeconfig kubeconfig >/dev/null 2>&1; then
        echo "Ingress vote-$CI_MERGE_REQUEST_ID already exists"
      else
        ./kubectl create ingress vote-$CI_MERGE_REQUEST_ID \
          --class=nginx \
          --rule="${VOTE_HOST}/*=vote:5000" \
          --kubeconfig kubeconfig
      fi

      if ./kubectl get ingress result-$CI_MERGE_REQUEST_ID --kubeconfig kubeconfig >/dev/null 2>&1; then
        echo "Ingress result-$CI_MERGE_REQUEST_ID already exists"
      else
        ./kubectl create ingress result-$CI_MERGE_REQUEST_ID \
          --class=nginx \
          --rule="${RESULT_HOST}/*=result:5001" \
          --kubeconfig kubeconfig
      fi

      ./kubectl get all --kubeconfig ./kubeconfig
      

      echo "Access the vote endpoint at https://$VOTE_HOST"
      echo "Access the result endpoint at https://$RESULT_HOST"
      echo "Access the \`vote\` endpoint at [\`$VOTE_HOST\`.](https://$VOTE_HOST)" 
      echo "Access the \`result\` endpoint at [\`$RESULT_HOST\`]($RESULT_HOST)."
